#include "stdafx.h"
#include "ConfigManager.h"
#include "../FileListWindow/FileListModel.h"
#include "../FileListWindow/FileListFrame.h"
#include "../FileListWindow/FileListTabClient.h"
#include "ConfigFileListWindow.h"
#include "../resource.h"

void CConfigFileListWindow::load(CONFIG_SECTION &Config)
{
	//EBhE̐ݒۑ
	StoreSetting=Config.Data[_T("StoreSetting")].GetNParam(TRUE);
	//EBhE̕ƍ
	Width=Config.Data[_T("Width")].GetNParam(FILELISTWINDOW_DEFAULT_WIDTH);
	if(Width<0){
		Width=FILELISTWINDOW_DEFAULT_WIDTH;
	}

	Height=Config.Data[_T("Height")].GetNParam(FILELISTWINDOW_DEFAULT_HEIGHT);
	if(Height<0){
		Height=FILELISTWINDOW_DEFAULT_HEIGHT;
	}

	//c[r[̕
	TreeWidth=Config.Data[_T("TreeWidth")].GetNParam(FILELISTWINDOW_DEFAULT_TREE_WIDTH);
	if(TreeWidth<0){
		TreeWidth=175;
	}
	//Xgr[̃X^C(Default:LVS_ICON)
	ListStyle=Config.Data[_T("ListStyle")].GetNParam(0);
	if(
		(LVS_LIST!=ListStyle)&&
		(LVS_REPORT!=ListStyle)&&
		(LVS_SMALLICON!=ListStyle)&&
		(LVS_ICON!=ListStyle)
	)ListStyle=LVS_ICON;

	//---------
	//\[g̐ݒ
	//J
	SortColumn=Config.Data[_T("SortColumn")].GetNParam(FILEINFO_INVALID,FILEINFO_LAST_ITEM,FILEINFO_INVALID);
	///~
	SortDescending=Config.Data[_T("Descending")].GetNParam(TRUE);
	//----------
	//EBhËʒuۑ
	StoreWindowPosition=Config.Data[_T("StoreWindowPosition")].GetNParam(FALSE);
	//EBhE̍W
	WindowPos_x=Config.Data[_T("x")].GetNParam(0);
	WindowPos_y=Config.Data[_T("y")].GetNParam(0);
	//---------
	//ӖȃpX𖳎邩
	IgnoreMeaninglessPath=Config.Data[_T("IgnoreMeaninglessPath")].GetNParam(TRUE);
	//Kw\𖳎邩
	FileListMode=(FILELISTMODE)Config.Data[_T("FileListMode")].GetNParam(0,FILELISTMODE_LAST_ITEM,0);
	//---------
	//߂c[WJ
	ExpandTree=Config.Data[_T("ExpandTree")].GetNParam(FALSE);
	//oCgPʂŃt@CTCY\L
	DisplayFileSizeInByte=Config.Data[_T("DisplayFileSizeInByte")].GetNParam(FALSE);
	//[ESC]L[ŏI
	ExitWithEscape=Config.Data[_T("ExitWithEscape")].GetNParam(FALSE);
	//^u\gȂȂTRUE
	DisableTab=Config.Data[_T("DisableTab")].GetNParam(FALSE);
	//EBhEɕۂȂTRUE
	KeepSingleInstance=Config.Data[_T("KeepSingleInstance")].GetNParam(FALSE);

	//Xgr[J̕я
	{
		CString Buffer=Config.Data[_T("ColumnOrder")];
		if(Buffer.IsEmpty()){
			for(int i=0;i<FILEINFO_ITEM_COUNT;i++){
				//z񏉊
				ColumnOrderArray[i]=i;
			}
		}else{
			//J̕я擾
			int Index=0;
			LPCTSTR lpArrayString=Buffer;
			for(;_T('\0')!=*lpArrayString&&Index<FILEINFO_ITEM_COUNT;Index++){
				CString Temp;
				for(;;){
					if(_T(',')==*lpArrayString||_T('\0')==*lpArrayString){
						lpArrayString++;
						break;
					}else{
						Temp+=*lpArrayString;
						lpArrayString++;
					}
				}
				ColumnOrderArray[Index]=_ttoi(Temp);
				if(ColumnOrderArray[Index]<-1||ColumnOrderArray[Index]>=FILEINFO_ITEM_COUNT){
					ColumnOrderArray[Index]=Index;
				}
			}
		}
	}
	//֘AtŊJ/ۂgq
	if(has_key(Config.Data,_T("OpenAssocAccept"))){
		OpenAssoc.Accept=Config.Data[_T("OpenAssocAccept")];
	}else{
		OpenAssoc.Accept=CString(MAKEINTRESOURCE(IDS_FILELIST_OPENASSOC_DEFAULT_ACCEPT));
	}

	//
	if(has_key(Config.Data,_T("OpenAssocDeny"))){
		OpenAssoc.Deny=Config.Data[_T("OpenAssocDeny")];
	}else{
		OpenAssoc.Deny=CString(MAKEINTRESOURCE(IDS_FILELIST_OPENASSOC_DEFAULT_DENY));
	}

	//%PATHEXT%Ŏw肳ꂽt@CJȂȂTRUE
	DenyPathExt=Config.Data[_T("DenyPathExt")].GetNParam(TRUE);
}

void CConfigFileListWindow::loadMenuCommand(CONFIG_SECTION &Config,CMenuCommandItem &mci)
{
	//uvOŊJvj[̃R}h
	//vÕpX
	mci.Path=Config.Data[_T("Path")];
	//p[^
	mci.Param=Config.Data[_T("Param")];
	//fBNg
	mci.Dir=Config.Data[_T("Dir")];
	//LvV
	mci.Caption=Config.Data[_T("Caption")];
}


void CConfigFileListWindow::store(CONFIG_SECTION &Config)const
{
	//EBhE̐ݒۑ
	Config.Data[_T("StoreSetting")]=StoreSetting;
	if(StoreSetting){
		//EBhE̕ƍ
		Config.Data[_T("Width")]=Width;
		Config.Data[_T("Height")]=Height;
		//c[r[̕
		Config.Data[_T("TreeWidth")]=TreeWidth;
		//Xgr[̃X^C
		Config.Data[_T("ListStyle")]=ListStyle;
		//---------
		//\[g̐ݒ
		//J
		Config.Data[_T("SortColumn")]=SortColumn;
		///~
		Config.Data[_T("Descending")]=SortDescending;
	}
	//----------
	//EBhËʒuۑ
	Config.Data[_T("StoreWindowPosition")]=StoreWindowPosition;
	if(StoreWindowPosition){
		//EBhE̍W
		Config.Data[_T("x")]=WindowPos_x;
		Config.Data[_T("y")]=WindowPos_y;
	}
	//---------
	//ӖȃpX𖳎邩
	Config.Data[_T("IgnoreMeaninglessPath")]=IgnoreMeaninglessPath;
	//Kw\𖳎邩
	Config.Data[_T("FileListMode")]=FileListMode;
	//---------
	//߂c[WJ
	Config.Data[_T("ExpandTree")]=ExpandTree;
	//oCgPʂŃt@CTCY\L
	Config.Data[_T("DisplayFileSizeInByte")]=DisplayFileSizeInByte;
	//[ESC]L[ŏI
	Config.Data[_T("ExitWithEscape")]=ExitWithEscape;
	//^u\gȂȂTRUE
	Config.Data[_T("DisableTab")]=DisableTab;
	//EBhEɕۂȂTRUE
	Config.Data[_T("KeepSingleInstance")]=KeepSingleInstance;

	//Xgr[J̕я
	{
		CString Buffer;
		for(int i=0;i<FILEINFO_ITEM_COUNT;i++){
			Buffer.AppendFormat(_T("%d"),ColumnOrderArray[i]);
			if(i!=FILEINFO_ITEM_COUNT-1){
				Buffer+=_T(",");
			}
		}
		Config.Data[_T("ColumnOrder")]=Buffer;
	}
	//֘AtŊJ/ۂgq
	//
	Config.Data[_T("OpenAssocAccept")]=OpenAssoc.Accept;
	//
	Config.Data[_T("OpenAssocDeny")]=OpenAssoc.Deny;

	//%PATHEXT%Ŏw肳ꂽt@CJȂȂTRUE
	Config.Data[_T("DenyPathExt")]=DenyPathExt;
}

void CConfigFileListWindow::storeMenuCommand(CONFIG_SECTION &Config,const CMenuCommandItem &mci)const
{
	//vÕpX
	Config.Data[_T("Path")]=mci.Path;
	//p[^
	Config.Data[_T("Param")]=mci.Param;
	//fBNg
	Config.Data[_T("Dir")]=mci.Dir;
	//LvV
	Config.Data[_T("Caption")]=mci.Caption;
}

void CConfigFileListWindow::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("FileListWindow")));

	//uvOŊJvj[̃R}h
	//Â̔j
	MenuCommandArray.clear();
	for(UINT iIndex=0;iIndex<USERAPP_MAX_NUM;iIndex++){
		CString strSectionName;
		strSectionName.Format(_T("UserApp%d"),iIndex);
		if(!ConfMan.HasSection(strSectionName)){
			break;
		}else{
			CMenuCommandItem mci;
			loadMenuCommand(ConfMan.GetSection(strSectionName),mci);
			MenuCommandArray.push_back(mci);
		}
	}
}

void CConfigFileListWindow::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("FileListWindow")));

	//uvOŊJvj[̃R}h
	//---ÂZNV̔j
	for(UINT iIndex=0;iIndex<USERAPP_MAX_NUM;iIndex++){
		CString strSectionName;
		strSectionName.Format(_T("UserApp%d"),iIndex);
		if(!ConfMan.HasSection(strSectionName)){
			break;
		}else{
			ConfMan.DeleteSection(strSectionName);
		}
	}
	//---f[^̏㏑
	for(UINT iIndex=0;iIndex<MenuCommandArray.size();iIndex++){
		CString strSectionName;
		strSectionName.Format(_T("UserApp%d"),iIndex);
		storeMenuCommand(ConfMan.GetSection(strSectionName),MenuCommandArray[iIndex]);
	}
}

