#pragma once
#include "FileListTabItem.h"
#include "../resource.h"

#define FILELISTWINDOW_DEFAULT_TREE_WIDTH	175

class CFileListFrame;
enum DLL_ID;
struct CConfigFileListWindow;
//class CFileListTabClient:public CTabViewImpl<CFileListTabClient>,public CEventDispatcher
class CFileListTabClient:public CTabView,public CEventDispatcher
{
public:
	//DECLARE_WND_SUPERCLASS(NULL, CTabCtrl::GetWndClassName())
	//DECLARE_WND_CLASS_EX(_T("LF_TabView"), 0, COLOR_APPWORKSPACE)
	BOOL PreTranslateMessage(MSG* pMsg);
protected:
	CSmartPtrCollection<CFileListTabItem> m_GC;
	//HWND				m_hFrameWnd;
	CFileListFrame&		m_rFrameWnd;
	CConfigManager&		m_rConfig;
	int					m_ColumnOrderArray[FILEINFO_ITEM_COUNT];	//Xgr[J̕я
	bool				m_bShowTab;

	CFileListTabItem*	m_lpPrevTab;

	//eXgr[ŋʉݒ
	int		m_nTreeWidth;
	bool	m_bSortDescending;
	int		m_nSortKeyType;
	DWORD	m_dwListStyle;
	FILELISTMODE	m_ListMode;//^uԂŋL͂Aۑ̂߂Ɏgp
protected:
	BEGIN_MSG_MAP_EX(CFileListTabClient)
		//MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_SIZE(OnSize)
		NOTIFY_CODE_HANDLER_EX(NM_SETFOCUS, OnWndStateChanged)
		NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnWndStateChanged)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TCN_SELCHANGING, OnTabSelChanging)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TCN_SELCHANGE, OnTabSelChanged)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TBVN_PAGEACTIVATED, OnTabSelChanged)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TBVN_CONTEXTMENU,OnContextMenu)	//^uj[
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_ARCHIVE,OnExtractArchive)
	if(GetActivePage()!=-1)CHAIN_COMMANDS_MEMBER(GetCurrentTab()->ListView)
		CHAIN_MSG_MAP(CTabView)
		REFLECT_NOTIFICATIONS()
		DEFAULT_REFLECTION_HANDLER()
	ALT_MSG_MAP(1)	//^uRg[
		MSG_WM_MBUTTONUP(OnMButtonUp)	//}EXzC[({^)NbN
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TCN_SELCHANGING, OnTabSelChanging)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TCN_SELCHANGE, OnTabSelChanged)
		CHAIN_MSG_MAP_ALT(CTabView,1)
	END_MSG_MAP()
protected:
	//---Cxgnh
	LRESULT OnDestroy();
	void OnSize(UINT uType, CSize &size);
	LRESULT OnTabSelChanging(LPNMHDR pnmh);
	LRESULT OnTabSelChanged(LPNMHDR pnmh);
	LRESULT OnWndStateChanged(LPNMHDR pnmh);
	LRESULT OnContextMenu(LPNMHDR pnmh);
	void OnMButtonUp(UINT, CPoint&);
	void OnExtractArchive(UINT,int,HWND);	//A[JCuׂĉ
protected:
	int CreateNewTab(const CConfigFileListWindow& ConfFLW);
	void ClearAllTabs();
	void RemoveTab(int);
	void RemoveTabExcept(int);
	void FitClient();
	void OnActivateTab(int newIdx);
	void OnDeactivateTab(CFileListTabItem*);
	void GetTabSettingsToClient(CFileListTabItem*);	//w肵^u̐ݒoϐɓǂݍ
	void UpdateClientArea();
public:
	CFileListTabClient(CConfigManager&,CFileListFrame&);
	virtual ~CFileListTabClient(){ClearAllTabs();}
	//void SetFrameWnd(HWND hWnd){m_hFrameWnd=hWnd;}
	CFileListTabItem* GetCurrentTab();

	void ReloadArchiverIfLost();

	HRESULT OpenArchiveInTab(LPCTSTR lpszArc,DLL_ID forceID,const CConfigFileListWindow& ConfFLW,LPCTSTR lpMutexName,HANDLE hMutex,CString &strErr);
	HRESULT ReopenArchiveFile(FILELISTMODE,int nPage=-1);
	bool ReopenArchiveFileAll();
	FILELISTMODE GetFileListMode();

	void StoreSettings(CConfigFileListWindow&);

	void SetCurrentTab(int idx);
	void SetCurrentTab(HANDLE);
	void CloseCurrentTab(){RemoveTab(GetActivePage());}

	DWORD GetListViewStyle();
	void SetListViewStyle(DWORD);

	void ShowTabCtrl(bool bShow);
	bool IsTabEnabled()const{return m_bShowTab;}
};
